import pygame
import style, object, background, form

class Widget(object.Object):
    def __init__(self,**params): 
        object.Object.__init__(self) 
        params.setdefault('decorate',True)
        self.rect = pygame.Rect(params.get('x',0),params.get('y',0),params.get('width',0),params.get('height',0))
        self.style = style._style(self)
        for att in ('align','valign','x','y','width','height','color','font','background'):
            if att in params: setattr(self.style,att,params[att])
        for k,v in params.get('style',{}).items():
            setattr(self.style,k,v)
            if k in ('border','margin','padding'):
                for kk in ('top','bottom','left','right'):
                    setattr(self.style,'%s_%s'%(k,kk),v)
        
        self.cls = "default"
        if 'cls' in params: self.cls = params['cls']
        if 'name' in params:    
            self.name = params['name']
            if hasattr(form.Form,'form') and form.Form.form != None: 
                form.Form.form.add(self)
                self.form = form.Form.form
        if 'value' in params: self.value = params['value']
        self.pcls = ""
        
        if type(self.style.background) != int:
            self.background = background.Background(self)    
            
        import app
        if params['decorate']: app.App.app.theme.decorate(self)
    
    def focus(self):
        if getattr(self,'container',None) != None: 
            if self.container.myfocus != self:  ## by Gal Koren
                self.container.focus(self)
    def blur(self): 
        if getattr(self,'container',None) != None: self.container.blur(self)
    def close(self): 
        if getattr(self,'container',None) != None: self.container.close(self)
    def resize(self,width=None,height=None):
        """resize this widget and any subwidgets"""
        return self.style.width, self.style.height
    def chsize(self):
        """call this if the widget needs to be resized, implicitly calls repaint"""
        #print self.__class__.__name__,'reresize'
        if not hasattr(self,'container'): return
        import app
        if hasattr(app.App,'app'):
            w,h = self.rect.w,self.rect.h
            w2,h2 = self.resize()
            if w2 != w or h2 != h:
                #print 'app resize'
                app.App.app.chsize()
            else: 
                self.repaint()
        

    def update(self,s): pass
    def paint(self,s): pass
    def repaint(self): 
        if getattr(self,'container',None) != None: self.container.repaint(self)
    def repaintall(self):
        if getattr(self,'container',None) != None: self.container.repaintall()
    def reupdate(self): 
        if getattr(self,'container',None) != None: self.container.reupdate(self)
    def next(self): 
        if getattr(self,'container',None) != None: self.container.next(self)
    def previous(self): 
        if getattr(self,'container',None) != None: self.container.previous(self)
    def open(self):
        if getattr(self,'container',None) != None: self.container.open(self)
    
    def get_abs_rect(self):
        """ by gal koren """
        x, y = self.rect[:2]
        c = getattr(self,'container',None)
        while c:
            x += c.rect[0]
            y += c.rect[1]
            c = getattr(c,'container',None)
        return pygame.Rect(x, y, self.rect.w, self.rect.h)
