from pgu import engine, gui, timer
import pygame
from pygame.locals import *
import os
from slideshow import *

import game_config
        
class PlaySlideShow(engine.State):
    def init(self):
        exec open(self.value["slideshow"]).read()
        self.slides = MySlideShow()
        self.sound = pygame.mixer.Sound(self.slides.sound_file)
        self.sound.play(self.slides.loop_sound)
        self.start_time = None 
        self.quit = 0
        
    def loop(self):
        if 0:
            self.quit = 1
            
        if self.quit:
            self.sound.stop()
            return self.value["next_state"](self.game)
        
    def update(self, screen):
        if self.start_time is None:
            self.start_time = -1
            return
        if self.start_time < 0: 
            self.start_time = pygame.time.get_ticks()

        surf = self.slides.getSurface(pygame.time.get_ticks()-self.start_time)
        if surf is None:
            self.quit = 1
            return
        screen.blit( surf, (0, 0))
        pygame.display.flip()
        
    def event(self, evt):
        if evt.type is QUIT: self.quit = 1
        if evt.type is KEYDOWN: self.quit = 1
        
class Viewer(engine.Game):
    def init(self):
        self.parameters = game_config
        self.screen = pygame.display.set_mode(
                          (self.parameters.screenWidth, self.parameters.screenHeight), 
                          SWSURFACE | self.parameters.fullscreen)
        self.screen.fill((255,255,255))
        pygame.display.flip()
        pygame.mixer.init()
        pygame.font.init()
        self.timer = timer.Timer(self.parameters.framesPerSecond)
        

    def tick(self):
        self.timer.tick()
        
        
        
if __name__ == "__main__":
   
    filename = "ejemplo_slide.py"
    game = Viewer()
    game.run(PlaySlideShow(game, dict(slideshow=filename, next_state=engine.Quit)))    
