import turbogears
from turbogears import controllers
from model import *
import datetime
import cherrypy
from turbogears import validators

class Root(controllers.Root):
    @turbogears.expose(html="stim.templates.index")
    def index(self):
        import time
        return dict(now=time.ctime())
    
    @turbogears.expose(html="stim.templates.downloads")
    def downloads(self):
        import time
        return dict(now=time.ctime())
    @turbogears.expose(html="stim.templates.viewHighScores", 
                        validators={'levelId':validators.Int(), 'highlight':validators.Int()})
    def viewHighScore(self, highlight=None, level = 1, sort=None, order=None):
        levels = Level.select()
        lvl = Level.get(level)
        scoreList = lvl.highScoreEntries
        cols = ('userName', 'replicationCost', 'researchCost', 'buildTime', 'executionTime')

        if sort in cols:
            if order == 'desc':
                ordCmp = lambda a,b: cmp(getattr(b,sort),getattr(a,sort))
            else:
                ordCmp = lambda a,b: cmp(getattr(a,sort),getattr(b,sort))
            scoreList.sort(ordCmp)
            
        return {'scoreList':scoreList,'highlight':highlight, 'levels':levels, 'level':lvl, 'sort':sort, 'order':order, 'cols':cols} 
    
    @turbogears.expose(validators={'buildTime':validators.Int(),
                                    'executionTime':validators.Int(),
                                    'levelID':validators.Int(),
                                    'researchCost':validators.Int(),
                                    'replicationCost':validators.Int()})
    def addHighScore(self, *args, **kwds):
        userIp = cherrypy.request.remoteAddr
        lvl = Level.get(kwds['levelID'])
        try:
            HighScoreEntry(userName = kwds['userName'], userIp = userIp,
                        replicationCost= kwds['replicationCost'],
                        researchCost = kwds['researchCost'],
                        buildTime = kwds['buildTime'], executionTime = kwds['executionTime'],
                        machine=kwds['machine'], level=lvl)
            return 'ok'
        except:
            pass